from org.bukkit.inventory import ItemStack
from org.bukkit.inventory import ShapedRecipe
from org.bukkit.enchantments import Enchantment
from org.bukkit.inventory.meta import ItemMeta
from org.bukkit.event.entity import ProjectileHitEvent
from org.bukkit.entity import EntityType
from org.bukkit.entity import Player


class ListenerPlugin(PythonListener):
    @PythonEventHandler(ProjectileHitEvent, EventPriority.NORMAL) 
    def onEvent(self, event):
        geschoss = event.getEntity()

        if geschoss.getType() == EntityType.ARROW:
            schuetze = geschoss.getShooter()
            if isinstance(schuetze, Player):
                gegenstand = schuetze.getItemInHand()
                metaData = gegenstand.getItemMeta()
                if metaData.getDisplayName()== "Enderbogen":
                    schuetze.teleport(geschoss.getLocation())


class EnderbogenPlugin(PythonPlugin):
    def onEnable(self):
        enderbogen = ItemStack(bukkit.Material.BOW)
        metaData = enderbogen.getItemMeta()
        metaData.setDisplayName("Enderbogen")
        enderbogen.setItemMeta(metaData)
        enderbogen.addUnsafeEnchantment(Enchantment.LUCK, 1)

        enderbogenRezept = ShapedRecipe(enderbogen)
        enderbogenRezept.shape("*S/", "S*/", "*S/")
        enderbogenRezept.setIngredient('/', bukkit.Material.STICK)
        enderbogenRezept.setIngredient('S', bukkit.Material.STRING)
        enderbogenRezept.setIngredient('*', bukkit.Material.ENDER_PEARL)
        self.getServer().addRecipe(enderbogenRezept)

        pluginManager = self.getServer().getPluginManager()
        listener = ListenerPlugin()
        pluginManager.registerEvents(listener, self)

        pass