from org.bukkit.inventory import ItemStack
from org.bukkit.inventory import ShapelessRecipe
from org.bukkit.enchantments import Enchantment
from org.bukkit.inventory.meta import ItemMeta
from org.bukkit.event.player import PlayerInteractEvent
from org.bukkit.block import BlockFace

class ListenerPlugin(PythonListener):
    @PythonEventHandler(PlayerInteractEvent, EventPriority.NORMAL) 
    def onEvent(self, event):
        gegenstand = event.getItem()
        metaData = gegenstand.getItemMeta()

        if metaData.getDisplayName() == "Feuerschwert":
            block = event.getClickedBlock()
            blockH = block.getRelative(BlockFace.UP)
            blockH.setType(bukkit.Material.FIRE)
            event.setCancelled(True)

class FeuerschwertPlugin(PythonPlugin):
    def onEnable(self):
        feuerschwert = ItemStack(bukkit.Material.IRON_SWORD)
        metaData = feuerschwert.getItemMeta()
        metaData.setDisplayName("Feuerschwert")
        feuerschwert.setItemMeta(metaData)
        feuerschwert.addUnsafeEnchantment(Enchantment.LUCK, 1)

        feuerschwertRezept = ShapelessRecipe(feuerschwert)
        feuerschwertRezept.addIngredient(bukkit.Material.IRON_SWORD)
        feuerschwertRezept.addIngredient(bukkit.Material.FLINT_AND_STEEL)
        self.getServer().addRecipe(feuerschwertRezept)

        pluginManager = self.getServer().getPluginManager()
        listener = ListenerPlugin()
        pluginManager.registerEvents(listener, self)

        pass