import os.path
import pickle
from org.bukkit.entity import Player

class SchilderEintrag:
    def __init__(self, schild, besitzer):
        self.__schild = {"x": int(schild.getLocation().getX()), "y": int(schild.getLocation().getY()), "z": int(schild.getLocation().getZ())}
        self.__besitzer = str(besitzer)

    def getSchild(self, welt):
        return welt.getBlockAt(self.__schild.get("x"), self.__schild.get("y"), self.__schild.get("z")).getState()

    def getBesitzer(self):
        return self.__besitzer

class SchilderPlugin(PythonPlugin):
    schilderListe = None

    def onEnable(self):
        global schilderListe
        pfad = self.getDataFolder().getPath() + "/schilderListe.pkl"

        if os.path.isfile(pfad):
            datei = open(pfad, "rb")
            schilderListe = pickle.load(datei)
        else:
            schilderListe = []

        pass

    def onDisable(self):
        global schilderListe

        if len(schilderListe) > 0:
            if not self.getDataFolder().exists():
                self.getDataFolder().mkdirs()

            pfad = self.getDataFolder().getPath() + "/schilderListe.pkl"
            datei = open(pfad, "wb")
            pickle.dump(schilderListe, datei)

    def onCommand(self, sender, command, label, args):
        global schilderListe

        if isinstance(sender, Player):
            spieler = sender
            welt = spieler.getWorld()

            if len(args) < 1:
                spieler.sendMessage("Bitte Schild-Befehl angeben!")
            elif args[0] == "bauen":
                #Schild platziert
                finalBlock = spieler.getLocation()
                blockListe = spieler.getLineOfSight(None, 30)
                
                for block in blockListe:
                    if block.getType() == bukkit.Material.AIR:
                        finalBlock = block
                    else:
                        break

                rotation = spieler.getLocation().getYaw()
                rotation = (rotation + 180) % 360 #entgegengesetzte Richtung
                rotation = rotation / 22 #umwandeln fuer Schild

                finalBlock.setTypeIdAndData(bukkit.Material.SIGN_POST.getId(), int(rotation), True)
                
                #Schild zu Liste hinzufuegen
                schild = finalBlock.getState()
                eintrag = SchilderEintrag(schild, spieler.getUniqueId())
                schilderListe.append(eintrag)
                spieler.sendMessage("Das neu gebaute Schuld hat die ID " + str(schilderListe.index(eintrag)))
            elif args[0] == "text":
                if len(args) < 4:
                    spieler.sendMessage("Bitte Schild-ID, Zeile und Text angeben!")
                else:
                    #parameter lesen
                    schildId = int(args[1])
                    zeile = int(args[2])
                    text = args[3]
                    for i in range(4, len(args)):
                        text = text + " " + args[i]

                    #id pruefen
                    if (schildId < 0) | (schildId >= len(schilderListe)):
                        spieler.sendMessage("Falsche Schild-ID!")
                    #spieler pruefen
                    elif schilderListe[schildId].getBesitzer() != str(spieler.getUniqueId()):
                        spieler.sendMessage("Dieses Schild gehoert einem anderen Spieler!")
                    #text zuweisen
                    else:
                        schild = schilderListe[schildId].getSchild(welt)
                        schild.setLine(zeile, text)
                        schild.update()
            else:
                spieler.sendMessage("Unbekannter Schild-Befehl!")
        else:
            self.getLogger().info("Dieser Befehl kann nur von Spielern ausgefuehrt werden!")

        return True