from org.bukkit.event.player import PlayerPickupItemEvent
from org.bukkit.event.player import PlayerJoinEvent
from org.bukkit.entity import Player
from org.bukkit.inventory import ItemStack
import random

global highscore
global gesuchterGegenstand
global anzahl

def getHighscoreForPlayer(player):
    global highscore
    for index in range(len(highscore)):
        if player.getUniqueId().toString() == highscore[index].getUniqueId():
            return highscore[index]
    #noch kein highscore vorhanden
    highscore.append(Highscore(player.getUniqueId().toString(), player.getName()))
    return highscore[len(highscore)-1]

class Highscore:
    def __init__(self, uniqueId, name):
        self.__uniqueId = uniqueId
        self.__name = name
        self.__punkte = 0

    def getUniqueId(self):
        return self.__uniqueId

    def getName(self):
        return self.__name

    def getPunkte(self):
        return self.__punkte

    def plusPunkt(self):
        self.__punkte = self.__punkte + 1

    def nullPunkte(self):
        self.__punkte = 0

class SammelListener(PythonListener):
    def __init__(self, plugin):
        self.plugin = plugin
        super(SammelListener, self).__init__()

    @PythonEventHandler(PlayerPickupItemEvent, EventPriority.NORMAL)
    def onEvent(self, event):
        global gesuchterGegenstand
        global anzahl

        spieler = event.getPlayer()

        if event.getItem().getItemStack().getType() == gesuchterGegenstand:
            highscore = getHighscoreForPlayer(spieler)
            highscore.plusPunkt()
            if highscore.getPunkte() >= anzahl:
                spieler.sendMessage("Herzlichen Glueckwunsch, du hast die Runde gewonnen!")
                spieler.giveExp(50)
                self.plugin.neueRundeStarten()
            else:
                spieler.sendMessage("Du musst noch " + str(anzahl-highscore.getPunkte()) + " Gegenstaende sammeln.")

class JoinListener(PythonListener):
    @PythonEventHandler(PlayerJoinEvent, EventPriority.NORMAL) 
    def onEvent(self, event):
        global gesuchterGegenstand
        global anzahl
        spieler = event.getPlayer()
        getHighscoreForPlayer(spieler)
        spieler.sendMessage("Willkommen! Auf diesem Server wird das Sammelspiel gespielt. Sammle " + str(anzahl) + " " + gesuchterGegenstand.toString() + ", um zu gewinnen!")

class SammelspielPlugin(PythonPlugin):
    def onEnable(self):
        global highscore
        highscore = []
        pluginManager = self.getServer().getPluginManager()
        sListener = SammelListener(self)
        jListener = JoinListener()
        pluginManager.registerEvents(sListener, self)
        pluginManager.registerEvents(jListener, self)
        self.neueRundeStarten()

    def neueRundeStarten(self):
        global highscore
        global gesuchterGegenstand
        global anzahl

        for index in range(len(highscore)):
            highscore[index].nullPunkte()

        gegenstaende = [bukkit.Material.YELLOW_FLOWER, bukkit.Material.EGG, bukkit.Material.CACTUS]
        zufallszahl = random.randint(0, len(gegenstaende)-1)

        gesuchterGegenstand = gegenstaende[zufallszahl]
        anzahl = random.randint(1, 5)

        self.getServer().broadcastMessage("Neue Runde! Sammle " + str(anzahl) + "x " + gesuchterGegenstand.toString() + "!")

    def onCommand(self, sender, command, label, args):
        global anzahl
        global gesuchterGegenstand

        if isinstance(sender, Player):
            spieler = sender
            spieler.sendMessage("Sammle " + str(anzahl) + "x " + gesuchterGegenstand.toString() + "!")
        return True